#!/bin/sh -x
#
#	HDIP-3000V ver.1.0.0 -> ver.6.1.1 アップデートファイル
#
#	内容
#	/opt/RF/html以下のファイルを更新


target_dir="/opt/RF.new"		# 作業用ディレクトリ
org_dir="/opt/RF"				# オリジナルディレクトリ

# -------------------------------------------------
#	コマンド実行結果確認
#
#	コマンド実行失敗の場合は作業ディレクトリを削除し、終了
#
#	\param	$1	コマンド終了コード
# -------------------------------------------------

check_result() {
	if [ $1 -ne 0 ]; then
		rm -r /opt/RF.new
		exit $1
	fi
}


# ------------------------------------------------
#	ファイル置き換え
#
#	システムファイルなど、/opt/RF以外のファイルを置き換える
#
#	\param	$1	置き換えるファイルのディレクトリ
#	\param	$2	置き換えるファイルのファイル名
# ------------------------------------------------

replace_file() {
	# オリジナルをリネーム
	mv $1/$2 $1/$2.org
	check_result $?

	# 新ファイルをコピー
	cp $2 $1/$2

	# 失敗ならオリジナルを元に戻して終了
	cp_res=$?
	if [ $cp_res -ne 0 ]; then
		mv $1/$2.org $1/$2
		return cp_res
	fi

	# オリジナルを削除
	rm $1/$2.org
}


# move to update directory
cd /opt/RF/update

if [ -e /opt/RF.old ]; then
	rm -r /opt/RF.old
fi

# copy RF directory
cp -r /opt/RF $target_dir


# ===============================================
# update application
# ===============================================

# application
cp hdip3000v $target_dir/hdip3000v
check_result $?

cp hdip3000v.cfg.default $target_dir/hdip3000v.cfg.default
check_result $?

cp hdiplogging $target_dir/hdiplogging
check_result $?

./cfgmod dial.pulse_time 500
check_result $?

./cfgmod audio.codec_id 97
check_result $?

./cfgmod control.use_all_gpio 0
check_result $?

./cfgmod dial.contact_ip ""
check_result $?

./cfgmod ip_call.contact_addr ""
check_result $?

./cfgmod ip_call.port 23500
check_result $?

./cfgmod reconnect.enable 0
check_result $?

./cfgmod reconnect.times 1
check_result $?

# ver.6.1.1
./cfgmod audio.pkts_for_pback --remove
check_result $?

./cfgmod audio.pkts_for_pback_ip --remove
check_result $?

./cfgmod buffer.ngn_clear 4
check_result $?

./cfgmod buffer.ngn_opus 4
check_result $?

./cfgmod buffer.ngn_sbadpcm 4
check_result $?

./cfgmod buffer.ngn_tel 4
check_result $?

./cfgmod buffer.ngn_lpcm 4
check_result $?

./cfgmod buffer.ip_clear 12
check_result $?

./cfgmod buffer.ip_opus 12
check_result $?

./cfgmod buffer.ip_sbadpcm 12
check_result $?

./cfgmod buffer.ip_tel 12
check_result $?

./cfgmod buffer.ip_lpcm 12
check_result $?

./cfgmod reconnect.enable 0
check_result $?

./cfgmod reconnect.times 1
check_result $?

# /lib/systemd directory
replace_file /lib/systemd HDIP-3000V
check_result $?

chmod +x /lib/systemd HDIP-3000V

# web html directory
rm -rf $target_dir/html
cp -r html $target_dir
check_result $?

chmod -R a+rw $target_dir/html/img
check_result $?

chmod a+rw $target_dir/websetting/parameter.cfg

rm /lib/systemd/network/eth0.network


# ================================================
# update RF directory
mv /opt/RF /opt/RF.old
check_result $?

mv /opt/RF.new /opt/RF
check_result $?

chmod a+w /opt/RF/websetting

cp /opt/RF.old/log/HDIP_log.01.txt /opt/RF/log
rm -r /opt/RF.old
rm -rf /opt/.Trash-0
